diff a/src/hotspot/share/interpreter/abstractInterpreter.hpp b/src/hotspot/share/interpreter/abstractInterpreter.hpp
--- a/src/hotspot/share/interpreter/abstractInterpreter.hpp
+++ b/src/hotspot/share/interpreter/abstractInterpreter.hpp
@@ -57,13 +57,18 @@
   friend class TemplateInterpreterGenerator;
  public:
   enum MethodKind {
     zerolocals,                                                 // method needs locals initialization
     zerolocals_synchronized,                                    // method needs locals initialization & is synchronized
+    zerolocals_upcalls,                                         // method needs locals initialization & has runtime upcalls
+    zerolocals_synchronized_upcalls,                            // method needs locals initialization & is synchronized & has runtime upcalls
     native,                                                     // native method
     native_synchronized,                                        // native method & is synchronized
+    native_upcalls,                                             // native method & has runtime upcalls
+    native_synchronized_upcalls,                                // native method & is synchronized & has runtime upcalls
     empty,                                                      // empty method (code: _return)
+    empty_upcalls,                                              // empty method & has runtime upcalls (code: _return)
     getter,                                                     // getter method
     setter,                                                     // setter method
     abstract,                                                   // abstract method (throws an AbstractMethodException)
     method_handle_invoke_FIRST,                                 // java.lang.invoke.MethodHandles::invokeExact, etc.
     method_handle_invoke_LAST                                   = (method_handle_invoke_FIRST
